{===========================================================================}
{==                                                                       ==}
{==                       SUPER CORECTOR Version 5.2                      ==}
{==                  Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16384,65535,655355}

USES Dos,
     GUtils, GMemory, GList, GDialogs, GStdDlgs;

CONST
  Version   = 'Version 5.2';

TYPE
  PFindReplaceCollection = ^TFindReplaceCollection;
  TFindReplaceCollection = OBJECT(TCollection) END;

  PFindReplace = ^TFindReplace;
  TFindReplace = OBJECT(TObject)
    Find       : PString;
    Replace    : PString;
    CONSTRUCTOR Init(NEW_Find,NEW_Replace:STRING);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PCrackCollection = ^TCrackCollection;
  TCrackCollection = OBJECT(TCollection) END;

  PCrack = ^TCrack;
  TCrack = OBJECT(TObject)
    C_Name  : PString;
    F_Name  : PString;
    FR_Data : PFindReplaceCollection;
    CONSTRUCTOR Init(NEW_C_Name, NEW_F_Name: STRING;
                     NEW_FindReplace       : PFindReplaceCollection);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGamesCollection = ^TGamesCollection;
  TGamesCollection = OBJECT(TCollection) END;

  PGame = ^TGame;
  TGame = OBJECT(TObject)
    Name : PString;
    Data : PCrackCollection;
    CONSTRUCTOR Init(NEW_Name:STRING; NEW_Data:PCrackCollection);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PStr = ^TStr;
  TStr = OBJECT(TObject)
    Data: PString;
    CONSTRUCTOR Init(AData: STRING);
    DESTRUCTOR Done; VIRTUAL;
  END;

  { ----------------------------- LIST OBJECTS ---------------------------- }
  PGamesList = ^TGamesList;
  TGamesList = OBJECT(TList)
    FUNCTION  __GetLine     (ListPos:Integer): STRING;              VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer);                      VIRTUAL;
  END;

  PCracksList = ^TCracksList;
  TCracksList = OBJECT(TList)
    FUNCTION  __GetLine     (ListPos:Integer): STRING;              VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer);                      VIRTUAL;
  END;
  { ----------------------------------------------------------------------- }

VAR
  Database     : PGamesCollection; {Main data (all names, cracks, etc.)}
  StringData   : PCollection;      {Temporaly used to load datafile}
  FileName     : STRING;           {DATAFILE filename}
  LastUpdate   : STRING;           {Last DARAFILE Update}
  CurrentGame  : PGame;            {The game that is current selected}
  GamesList    : PGamesList;
  CracksList   : PCracksList;
  CracksCount  : Word;


PROCEDURE FatalError(ErrMsg: STRING);
BEGIN
  ClearLine(24,$7);
  Writeln;
  Writeln('FATAL ERROR: ',ErrMsg);
  Cursor(On);
  SetBlink(True);
  Halt(1);
END;

PROCEDURE ShowPGMLogo;
BEGIN
  ClrScr(7);
  FastWrite(9, 6,$D,'ķ ķ ''ķ   ');
  FastWrite(9, 7,$D,'                     ');
  FastWrite(9, 8,$D,' ķ    ķ           ');
  FastWrite(9, 9,$D,'               ');
  FastWrite(9,10,$D,'Ľ      Ľ             ');
  FastWrite(14,11,$D,'                    ');
  FastWrite(14,12,$D,'         ');
  FastWrite(14,13,$D,'    ');
  FastWrite(14,14,$D,'       ');
  FastWrite(14,15,$D,' ');
  FastWrite(14,16,$D,'                ');
  FastWrite(14,17,$D,'       ');
  FastWrite(14,18,$D,'             ');
  FastWrite(14,19,$D,'    ');
  FastWrite(14,20,$D,' ');
  ClearAttr(9,5,25,10,$0E);
END;

PROCEDURE About;
VAR OK: PButtons; UpY: Byte;
BEGIN
  UpY := MaxY DIV 2-9;
  OpenWin(10,UpY,60,20,$5D,$5F,Single1,'About');
  WriteBetween(10,70,UpY+2,$5E,' SUPER CORECTOR '+Version+' ');
  WriteBetween(10,70,UpY+3,$5E,' Copyright (C) 1994-96 By The GodFather ');
  WriteBetween(10,70,UpY+5,$4F,' THIS PROGRAM IS CARDWARE, SEND ME A POSTCARD ! ');
  WriteBetween(10,70,UpY+7,$57,' If you have any suggestions, bug reports or ');
  WriteBetween(10,70,UpY+8,$57,' information about this program please write ');
  WriteBetween(10,70,UpY+9,$57,' to me. I`ll reply to all letters or postcards ');
  WriteBetween(10,70,UpY+11,$57,' Contact me here: ');
  WriteBetween(10,70,UpY+13,$5B,' EMAIL: gf@top.bg ');
  WriteBetween(10,70,UpY+14,$5B,' EMAIL: gf@cybcom.net ');
  WriteBetween(10,70,UpY+15,$5B,' URL: http://georgi.top.bg/ ');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,UpY+18,btDefault);
  OK^.Process;
  Dispose(OK, Done);
  RmWin;
END;

PROCEDURE Success;
VAR OK: PButtons; Y: Byte;
BEGIN
  Y := MaxY DIV 2;
  OpenWin(18,Y-5,44,10,$5D,$5F,Special2,'Success');
  WriteBetween(20,60,Y-3,$5B,'Everything went OK !!!');
  WriteBetween(20,60,Y-1,$5E,'The game is CORECTED, so now you');
  WriteBetween(20,60,Y  ,$5E,'can start the game and enjoy !!!');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,Y+3,btDefault);
  OK^.Process;
  Dispose(OK, Done);
  RmWin;
END;

PROCEDURE Fail;
VAR OK: PButtons; Y: Byte;
BEGIN
  Y := MaxY DIV 2;
  OpenWin(14,Y-5,51,11,$4C,$4F,Special2,'Fail');
  WriteBetween(15,65,Y-3,$4F,'Sorry man.');
  WriteBetween(15,65,Y-1,$4E,'I could not find the byte pattern. May be');
  WriteBetween(15,65,Y  ,$4E,'the file is compressed. Try to uncompress it');
  WriteBetween(16,65,Y+1,$4E,'with UP.EXE and then try again with GSUPER.');
  InitPallette(WarningDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,Y+4,btDefault);
  OK^.Process;
  Dispose(OK, Done);
  RmWin;
END;

FUNCTION GetFileName(VAR AName: STRING): Boolean;
VAR FDlg: PDialog; VAR FName: STRING[12];
BEGIN
  FName       := AName;
  GetFileName := False;
  New(FDlg, Init(16,MaxY DIV 2-4,50,8,DefaultDialogPAL,Single1,'Change file name'));
  WITH FDlg^ DO
  BEGIN
    AddTxtInputLine(12,3,'~F~ile',kbAltF,17,3,12,ilFileName,FName);
    AddButtons;
     AddButton('    ~O~K    ',kbAltO,11,6,btDefault);
     AddButton('  ~C~ancel  ',kbAltC,30,6,btCancel);
    IF (Process(1) = 1)
      THEN BEGIN
             AName := FName;
             GetFileName := True;
           END;
  END;
  Dispose(FDlg, Done);
END;

FUNCTION ReplaceShortenings(ST: STRING): STRING;
VAR TmpST,S1,S2: STRING;
BEGIN
  TmpST := Copy(ST, Pos(' ',ST), (Length(ST)-Pos(' ',ST))+1 );
  S1 := St[1]; S2 := St[2];
  CASE S1[1] OF
    '!': S1 := 'Make';
    '@': S1 := 'Remove';
    '#': S1 := 'Stop';
    '$': S1 := 'Unlimited';
  END;
  CASE S2[1] OF
    '!': S2 := ' BALLS';
    '@': S2 := ' BOMBS';
    '#': S2 := ' BULLETS';
    '$': S2 := ' ENERGY';
    '%': S2 := ' LIFE';
    '^': S2 := ' LIFES';
    '&': S2 := ' MONEY';
    '*': S2 := ' MISSLES';
    '(': S2 := ' PASSWORDS';
    ')': S2 := ' SHIELD';
    '_': S2 := ' TIME';
    '+': S2 := ' TIMER';
   ELSE IF S2 = ' ' THEN S2 := '';
  END;
  TmpST := ' '+S1+S2+TmpST;
  IF TmpST[3] = ' ' THEN Delete(TmpST,1,3);
  ReplaceShortenings := TmpST;
END;


PROCEDURE WriteINFOFile;
VAR
  INFOFile: Text;
  AGame   : PGame;
  ACrack  : PCrack;
  Buffer  : Pointer;
  TMPStr  : STRING;
  I,R     : Word;

  PROCEDURE SetSTR(Ch1,Ch2,Ch3,Ch4:Char);
  BEGIN
    TMPStr := Replicate(94,Ch1);
    TMPStr[1 ] := Ch2;
    TMPStr[43] := Ch3;
    TMPStr[79] := Ch3;
    TMPStr[94] := Ch4;
  END;

BEGIN
  IF NOT PromptBox('Write INFO File?',False) THEN Exit;
  Assign(INFOFile,'GSUPER.INF');
  {$I-}
    Rewrite(INFOFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error creating GSUPER.INF',True);
    Exit;
  END;
  GetMem(Buffer,64000);
  SetTextBuf(INFOFile,Buffer^,64000);
  Writeln(INFOFile);
  Writeln(INFOFile,PadCenter('Full catalog of cracks in SUPER CORECTOR '+Version,80,' '));
  Writeln(INFOFile,#13#10);
  Writeln(INFOFile,PadCenter('TOTALS',80,' '));
  Writeln(INFOFile);
  Writeln(INFOFile,Replicate(31,' '),AddComas(Database^.Count)+' cracked games');
  Writeln(INFOFile,Replicate(31,' '),AddComas(CracksCount)+' cracks');
  Writeln(INFOFile);
  SetSTR('','','',''); Writeln(INFOFile,TMPStr);
  SetSTR(' ','','','');
  OverWrite(16,TMPStr,'GAME NAME');
  OverWrite(54,TMPStr,'WHAT IS CORECTED');
  OverWrite(83,TMPStr,'FILENAME');
  Writeln(INFOFile,TMPStr);
  SetSTR('','','',''); Writeln(INFOFile,TMPStr);
  {$I-}
  FOR I := 0 TO Database^.Count-1 DO
  BEGIN
    AGame := Database^.At(I);
    Write(INFOFile,' ',PadLeft(AGame^.Name^,40,' '));
    FOR R := 0 TO AGame^.Data^.Count - 1 DO
    BEGIN
      IF R <> 0 THEN Write(INFOFile,' ',Replicate(40,' '));
      ACrack := AGame^.Data^.At(R);
      TMPStr := ReplaceShortenings(ACrack^.C_Name^);
      Write  (INFOFile,'',PadLeft(TMPStr,35,' '));
      Writeln(INFOFile,' ',PadLeft(ACrack^.F_Name^,12,' '),' ');
    END;
    IF I = Database^.Count-1
      THEN SetSTR('','','','')
      ELSE SetSTR('','','','');
    Writeln(INFOFile,TMPStr);
  END;
  Close(INFOFile);
  FreeMem(Buffer,64000);
  {$I+}
  InfoBox('GSUPER.INF saved OK!',False);
END;



{---------------------------------------------------------------------------}
{---------------------------- OBJECT PROCEDURES ----------------------------}
{---------------------------------------------------------------------------}
FUNCTION RetString: STRING;
VAR PS: PStr;
BEGIN
  PS := StringData^.At(0);
  RetString := PS^.Data^;
  StringData^.AtFree(0);
END;

CONSTRUCTOR TFindReplace.Init(NEW_Find,NEW_Replace:STRING);
VAR I,R: Byte; S1,S2: STRING[2];
BEGIN
  IF NEW_Find[Length(NEW_Find)] = '+' THEN
  BEGIN
    NEW_Find[0]    := Chr(Ord(NEW_Find[0])-1);
    NEW_Replace[0] := Chr(Ord(NEW_Replace[0])-1);
  END;
  IF Odd(Length(NEW_Find))    THEN NEW_Find[0]    := Chr(Ord(NEW_Find[0])-1);
  IF Odd(Length(NEW_Replace)) THEN NEW_Replace[0] := Chr(Ord(NEW_Replace[0])-1);
  R := 0;
  FOR I := 1 TO Length(NEW_Find) DO
  BEGIN
    S1 := Copy(NEW_Find   ,I,2);
    S2 := Copy(NEW_Replace,I,2);
    Inc(I); Inc(R);
    NEW_Find   [R] := Chr(HexToDec(S1));
    NEW_Replace[R] := Chr(HexToDec(S2));
  END;
  NEW_Find[0]    := Chr(Ord(NEW_Find[0]) DIV 2);
  NEW_Replace[0] := Chr(Ord(NEW_Replace[0]) DIV 2);
  Find    := NewStr(NEW_Find);
  Replace := NewStr(NEW_Replace);
END;

DESTRUCTOR TFindReplace.Done;
BEGIN
  DisposeStr(Find);
  DisposeStr(Replace);
END;


{---------------------------------------------------------------------------}
CONSTRUCTOR TCrack.Init(NEW_C_Name,NEW_F_Name: STRING;
                        NEW_FindReplace      : PFindReplaceCollection );
BEGIN
  C_Name  := NewStr(NEW_C_Name);
  F_Name  := NewStr(NEW_F_Name);
  FR_Data := NEW_FindReplace;
END;

DESTRUCTOR TCrack.Done;
BEGIN
  DisposeStr(C_Name);
  DisposeStr(F_Name);
  Dispose(FR_Data,Done);
END;


{---------------------------------------------------------------------------}
CONSTRUCTOR TGame.Init(NEW_Name:STRING; NEW_Data:PCrackCollection);
BEGIN
  Name := NewStr(NEW_Name);
  Data := NEW_Data;
END;

DESTRUCTOR TGame.Done;
BEGIN
  DisposeStr(Name);
  Dispose(Data,Done);
END;


{---------------------------------------------------------------------------}
CONSTRUCTOR TStr.Init(AData: STRING);
BEGIN
  Data := NewStr(AData);
END;

DESTRUCTOR TStr.Done;
BEGIN
  DisposeStr(Data);
END;
{---------------------------------------------------------------------------}
{---------------------------- OBJECT PROCEDURES ----------------------------}
{---------------------------------------------------------------------------}


{---------------------------------------------------------------------------}
{------------------------------- READ DATABASE -----------------------------}
{---------------------------------------------------------------------------}
FUNCTION CheckFileHeader(FName: STRING): Boolean;
CONST
  ID_SIZE = 23;
  FILE_ID : STRING[ID_SIZE] = 'SUPER CORECTOR DATAFILE';
TYPE
  DATAFileHeader = RECORD
              ID : ARRAY[1..ID_SIZE] OF Char;
      LastUpdate : STRING[20];
  END;
VAR
  DataFile: FILE;
  Readen  : Word;
  Index   : Byte;
  Data    : DATAFileHeader;

BEGIN
  CheckFileHeader := True;
  Assign(DataFile,FName);
  {$I-}
    Reset(DataFile,1);
    BlockRead(DataFile,Data,SizeOf(Data),Readen);
    Close(DataFile);
  {$I+}
  FOR Index := 1 TO ID_SIZE DO
    IF Data.ID[Index] <> FILE_ID[Index]
      THEN CheckFileHeader := False;
  Data.LastUpdate[0] := #20;
  LastUpdate := Data.LastUpdate;
END;

PROCEDURE LoadText(FileName: STRING);
TYPE TBuffer = ARRAY[0..65534] OF Byte;
VAR
  Index: LongInt;
  Buffer: ^TBuffer;
  Readen: Word;
  OldLine,
  CurrLine: STRING;
  TempChar: Char;
  DataFile: FILE;
  StrLength: Byte;

  Max,
  Current: LongInt;

  PROCEDURE ShowGauge;
  VAR BarSize,Percent,XPos: Byte;
  BEGIN
    Percent := RetPercent(100,Max,Current);
    BarSize := Percent DIV 2;
    XPos    := 17;
    PlainWrite(XPos+(50 DIV 2)-1,24,IntToStr(Percent)+'%');
    Attribute (XPos,24,$F0,BarSize)
  END;

BEGIN
  Max := FSize(FileName);
  IF MemAvail < Max*2+65535 THEN FatalError('Not enough memory');
  Assign(DataFile,FileName);
  {$I-}
    Reset(DataFile,1); Seek(DataFile,45);
  {$I+}
  IF IOResult <> 0 THEN FatalError('Can''t open '+FileName);
  New(Buffer);
  StringData := New(PCollection, Init(1,1));
  Current := 0;
  OldLine := '';
  ShowGauge;
  REPEAT
    {$I-}
      BlockRead(DataFile,Buffer^,SizeOf(Buffer^),Readen);
    {$I+}
    IF IOResult <> 0 THEN FatalError('Can''t read from '+FileName);
    Index := 0;
    REPEAT
      Move(Buffer^[Index],CurrLine,250);
      IF Index = 0 THEN TempChar := CurrLine[0];
      CurrLine[0] := #250;
      StrLength   := Pos(#20,CurrLine)-1;
      CurrLine[0] := Chr(StrLength);
      IF Index = 0 THEN Insert(TempChar,CurrLine,1);
      IF Length(OldLine) <> 0 THEN
      BEGIN
        CurrLine := OldLine + CurrLine;
        OldLine := '';
      END;
      IF (Index+StrLength+1) >= Readen THEN
      BEGIN
        CurrLine[0] := #250;
        OldLine     := CurrLine;
        OldLine[0]  := Chr(SizeOf(Buffer^)-Index-1);
        CurrLine[0] := Chr(StrLength);
      END;
      Inc(Index,StrLength+1);

      Inc(Current,StrLength+1); ShowGauge;

      IF Index >= Readen THEN Break;
      IF MemAvail < 65535 THEN FatalError('Not enough memory');
      {-------------------------------}
      {-------------------------------}
      StringData^.Insert(New(PStr,Init(DecodeStr(CurrLine))));
      {-------------------------------}
      {-------------------------------}
    UNTIL Index >= Readen;
  UNTIL Readen <> SizeOf(Buffer^);
  {$I-}
    Close(DataFile);
  {$I+}
  Dispose(Buffer);
END;

PROCEDURE LoadCrackData;
VAR
  _GName: STRING;
  C_Data: PCrackCollection;

  PROCEDURE GetCrk; NEAR;
  VAR TmpDTA: PCrackCollection;
      Tmp_FR: PFindReplaceCollection;
      _CName, _FName, _Find, _Replace: STRING;

     PROCEDURE ReadFR;
     VAR FR_DTA: PFindReplaceCollection;
     BEGIN
       New(FR_DTA,Init(1,1));
       REPEAT
         _Find    := RetString;
         _Replace := RetString;
         FR_DTA^.Insert(New(PFindReplace, Init(_Find,_Replace)));
       UNTIL _Find[Length(_Find)] <> '+';
       Tmp_FR := FR_DTA;
     END;

  BEGIN
    New(TmpDTA,Init(1,1));
    REPEAT
      _CName := RetString; IF _CName = '<>' THEN Break;
      _FName := RetString; Inc(CracksCount);
      ReadFR;
      TmpDTA^.Insert(New(PCrack, Init(_CName,_FName,Tmp_FR)));
    UNTIL StringData^.Count = 0;
    C_Data := TmpDTA;
  END;

BEGIN
  FileName := 'GSUPER.DAT';
  IF NOT FindFile(FileName)
    THEN FatalError('Can''t find GSUPER.DAT');
  IF CheckFileHeader(FileName)
    THEN LoadText(FileName)
    ELSE FatalError(FileName+' is not SUPER CORECTOR Datafile');
  ClearLine(24,$7);
  Database := New(PGamesCollection, Init(1, 1));
  REPEAT
    _GName := RetString;
    IF _GName = '' THEN Break;
    GetCrk;
    Database^.Insert(New(PGame, Init(_GName,C_Data)));
  UNTIL StringData^.Count = 0;
  Dispose(StringData,Done);
END;
{---------------------------------------------------------------------------}
{------------------------------- READ DATABASE -----------------------------}
{---------------------------------------------------------------------------}


{ ------------------------------------------------------------------------- }
{ ----------------------------- CRACK THE GAME ---------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE CrackTheGame;
LABEL Quit;
CONST ARRAYSize = 64000;
TYPE TArray = ARRAY[1..ARRAYSize] OF Byte;
VAR
  TheGame     : PGame;
  TheCrack    : PCrack;
  FndRepColl  : PFindReplaceCollection;
  FindReplace : PFindReplace;

  SearchFor,
  ReplaceWith : STRING;

  SourceFile  : STRING;

  Index,
  R,T,
  Index2,
  Readen,
  Founded     : Word;
  Max,Current,
  Counts      : LongInt;
  Source      : FILE;
  Dest        : FILE OF Byte;

  FBuffer     : ^TArray;
  Error       : Byte;

  PROCEDURE DisplayTermometer;
  BEGIN
    PlainWrite(41,MaxY DIV 2,AddComas(RetPercent(100,Max,Current))+'%');
    Attribute (18,MaxY DIV 2,$F0,(RetPercent(50,Max,Current)));
  END;

  PROCEDURE MakeChanges;
  VAR Offset: LongInt;
  BEGIN
    Inc(Founded);
    Offset := LongInt(Counts*ArraySize) + Index2;
    {$I-}
      Seek(Dest,Offset);
      FOR Offset := 1 TO Length(ReplaceWith)
        DO Write(Dest,Byte(ReplaceWith[Offset]));
    {$I+}
    IF IOResult <> 0 THEN Error := 3;
  END;

BEGIN
  Error       := 0;
  Founded     := 0;
  TheGame     := Database^.At(GamesList^.LSTPosition-1);
  TheCrack    := TheGame^.Data^.At(CracksList^.LSTPosition-1);
  FndRepColl  := TheCrack^.FR_DATA;
  SourceFile  := TheCrack^.F_Name^;

  Assign(Source,SourceFile);
  Assign(Dest  ,SourceFile);
  {$I-}
    Reset(Source,1);
    Reset(Dest);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    InfoBox('Error opening '+SourceFile,True);
    Exit;
  END;
  Counts := 0;
  GetMem(FBuffer,SizeOf(FBuffer^));

  Current := 0;
  Max     := FileSize(Source) * FndRepColl^.Count;

  MkWin(13,MaxY DIV 2-4,59,6,$5D,Single1,'');
  WriteBetween(14,72,MaxY DIV 2-2,$5E,'Searching & Replacing bytes in '+SourceFile);

  FastWrite(18,MaxY DIV 2  ,$0F,Replicate(50,' '));
  PlainWrite(41,MaxY DIV 2,AddComas(RetPercent(100,Max,Current))+'%');

  FOR Index := 0 TO FndRepColl^.Count-1 DO
  BEGIN
    Counts      := 0;
    FindReplace := FndRepColl^.At(Index);
    SearchFor   := FindReplace^.Find^;
    ReplaceWith := FindReplace^.Replace^;
    Insert(' ',SearchFor,1);
    Seek(Source,0);
    REPEAT
      {$I-}
        BlockRead(Source,FBuffer^,SizeOf(FBuffer^),Readen);
      {$I+}
      IF IOResult <> 0 THEN BEGIN Error := 2; GOTO Quit; END;

      Inc(Current,Readen);
      FOR Index2 := 0 TO Readen DO
      BEGIN
        R:=1; T:=1;
        WHILE FBuffer^[Index2+R] = Ord(SearchFor[R+1]) DO
        BEGIN
          Inc(R);
          Inc(T);
        END;
        IF T = Length(SearchFor) THEN MakeChanges;
        IF Error <> 0 THEN GOTO Quit;
      END;
      DisplayTermometer;
      Inc(Counts);
    UNTIL Readen = 0;
  END;
Quit:
  FreeMem(FBuffer, SizeOf(FBuffer^));
  {$I-}
    Close(Source);
    Close(Dest);
  {$I+}
  RmWin;
  CASE Error OF
    2: InfoBox('Error reading '+SourceFile,True);
    3: InfoBox('Error writing in '+SourceFile,True);
  END;
  IF (Founded<>0) AND (Error=0) THEN Success ELSE Fail;
END; {CrackTheGame}



{ ------------------------------------------------------------------------- }
{ -------------------------- TCrackList ROUTINES -------------------------- }
{ ------------------------------------------------------------------------- }
PROCEDURE TCracksList.__HookListKeys(ListPos: Integer; VAR PressedKey:Word);
VAR TheCrack: PCrack;

  FUNCTION ChangeName: Boolean;
  VAR Name: STRING;
  BEGIN
    ChangeName := False;
    TheCrack   := CurrentGame^.Data^.At(ListPos-1);
    Name       := TheCrack^.F_Name^;
    IF Name = '?' THEN Name := '';
    IF (GetFileName(Name)) THEN
    BEGIN
      DisposeStr(TheCrack^.F_Name);
      IF Name = '' THEN Name := '?';
      TheCrack^.F_Name := NewStr(Name);
      ChangeName := True;
      IF Name = '?' THEN ChangeName := False;
    END;
  END;

  PROCEDURE Corect;
  VAR FName: STRING;
  BEGIN
    TheCrack := CurrentGame^.Data^.At(LSTPosition-1);
    FName    := TheCrack^.F_Name^;
    IF FName <> '?'
      THEN CrackTheGame
      ELSE IF ChangeName
             THEN CrackTheGame;
  END;

BEGIN
  CASE PressedKey OF
        kbF1: About;
       kbF10: WriteINFOFile;
     kbEnter: Corect;
     kbSpace: ChangeName;
      kbTab,
      kbsTab,
      kbLeft: EndOfList := True;
  END;
END;

FUNCTION TCracksList.__GetLine(ListPos: Integer): STRING;
VAR TheCrack: PCrack;
BEGIN
  TheCrack  := CurrentGame^.Data^.At(ListPos-1);
  __GetLine := ReplaceShortenings(TheCrack^.C_Name^);
END;

PROCEDURE TCracksList.__IdleListCall(ListPos: Integer);
VAR
  AnEntry : PGame;
  TheCrack: PCrack;
BEGIN
  AnEntry  := CurrentGame;
  TheCrack := AnEntry^.Data^.At(ListPos-1);
  FastWrite(63,MaxY-6,$1A,TheCrack^.F_Name^+Replicate(12-Length(TheCrack^.F_Name^),' '));
END;

PROCEDURE InitTCracksList;
BEGIN
  CurrentGame := DataBase^.At(GamesList^.LSTPosition-1);
  CracksList := New(PCracksList,
                         Init(42,              { ListX       : Byte;    }
                              7,               { ListY       : Byte;    }
                              38,              { BarSize     : Byte;    }
                              MaxY-14,         { Lines       : Byte;    }
                              CurrentGame^.Data^.Count, { MaxTopics   : Integer; }
                              False,           { SelectionON : Boolean; }
                              False,           { FastFindON  : Boolean; }
                              0,               { FastFindX   : Byte;    }
                              0,               { FastFindY   : Byte;    }
                              #0,              { FastFindCHR : Char;    }
                              True,            { ScrollerON  : Boolean; }
                              80,              { ScrollerX   : Byte;    }
                              7,               { ScrollerY1  : Byte;    }
                              MaxY-8,          { ScrollerY2  : Byte;    }
                              lDefaultPal));   { Pallette    : Pals;    }
  CracksList^.Process;
  Dispose(CracksList,Done);
  WriteVScrollBar(80,7,MaxY-8,$19,1,2);
END;


{ -------------------------------------------------------------------------- }
{ ----------------------------- TGamesList ROUTINES ------------------------ }
{ -------------------------------------------------------------------------- }
FUNCTION TGamesList.__GetLine(ListPos: Integer): STRING;
BEGIN
  CurrentGame := Database^.At(ListPos-1);
  __GetLine   := ' '+CurrentGame^.Name^;
END;

PROCEDURE TGamesList.__IdleListCall(ListPos: Integer);
VAR
  AnEntry : PGame;
  TheCrack: PCrack;
  NameSTR : PString;
  DataSTR : PString;
  TempSTR : STRING;
  I,R     : Word;
BEGIN
  AnEntry := Database^.At(ListPos-1);
  NameSTR := AnEntry^.Name;
  FastWrite(42,4,$1E,PadCenter(NameSTR^,38,' '));
  R := 7;
  FOR I := 1 TO MaxY-14 DO
  BEGIN
    TheCrack := AnEntry^.Data^.At(I-1);
    TempSTR := ReplaceShortenings(TheCrack^.C_Name^);
    FastWrite(42,R,$17,TempSTR+Replicate(38-Length(TempStr),' '));
    Inc(R);
    IF I = AnEntry^.Data^.Count THEN Break;
  END;
  ClearText(42,R,79,MaxY-8,$10);
  TheCrack := AnEntry^.Data^.At(0);
  FastWrite(63,MaxY-6,$1A,TheCrack^.F_Name^+Replicate(12-Length(TheCrack^.F_Name^),' '));
END;

PROCEDURE TGamesList.__HookListKeys(ListPos: Integer; VAR PressedKey:Word);
BEGIN
  CASE PressedKey OF
    kbF1: About;

kbCtrlF2: Success;
kbCtrlF3: Fail;

   kbF10: WriteINFOFile;

   kbTab,
  kbsTab,
 kbRight,
 kbEnter: BEGIN
               Attribute(2,ListY+Pred(CurrentY),$1F,39);
               InitTCracksList;
               Attribute(2,ListY+Pred(CurrentY),Pallette[lBar],39);
             END;
  END;
END;
{ -------------------------------------------------------------------------- }
{ -------------------------------------------------------------------------- }


PROCEDURE Initialize;
BEGIN
  Cursor(Off);
  SetBlink(False);
  MaxKeyboardSpeed;
  ShowPGMLogo;
  CracksCount := 0;
  PosCursor(1,22);
  LoadCrackData;
  SetPal(AltPAL);
  ClearLine(24,$07);
  FastWrite(1,1, $0A, PadCenter('SUPER CORECTOR '+Version,80,' '));
  FastWrite(1,MaxY,$0A, PadCenter('Copyright (C) 1994-96 By The GodFather',80,' '));
  FBox(1,2,80, MaxY-1,$19,Double1);
  WriteBetween(1 ,39,2,$1B,' Corected games ');
  WriteBetween(41,80,2,$1B,' What is corected ');
  SmartVLine(41, 2,MaxY-1,$19,SingleLine);
  SmartHLine(41,80,     6,$19,SingleLine);
  SmartHLine(41,80,MaxY-7,$19,SingleLine);
  SmartHLine(41,80,MaxY-5,$19,SingleLine);
  FastWrite(43,MaxY-6,$1E,'Game is corected in');
  FastWrite(43,MaxY-4,$1E,'Total games     '+AddComas(Database^.Count));
  FastWrite(43,MaxY-3,$1E,'Total cracks    '+AddComas(CracksCount));
  FastWrite(43,MaxY-2,$1E,'Datafile date   '+LastUpdate);
  SmartVLine(57,MaxY-5,MaxY-1,$19,SingleLine);
  ClearAttr(58,MaxY-4,79,MaxY-2,$1A);
  WriteVScrollBar(80,7,MaxY-8,$19,1,2);
  PosCursor(MaxX,MaxY);
  ClearAttr(MaxX,MaxY,MaxX,MaxY,$00);
  GamesList := New(PGamesList,
                         Init(2,               { ListX       : Byte;    }
                              3,               { ListY       : Byte;    }
                              39,              { BarSize     : Byte;    }
                              MaxY-4,          { Lines       : Byte;    }
                              Database^.Count, { MaxTopics   : Integer; }
                              False,           { SelectionON : Boolean; }
                              True,            { FastFindON  : Boolean; }
                              5,               { FastFindX   : Byte;    }
                              MaxY-1,          { FastFindY   : Byte;    }
                              '',             { FastFindCHR : Char;    }
                              True,            { ScrollerON  : Boolean; }
                              41,              { ScrollerX   : Byte;    }
                              3,               { ScrollerY1  : Byte;    }
                              MaxY-2,          { ScrollerY2  : Byte;    }
                              lDefaultPal));   { Pallette    : Pals;    }
  GamesList^.Process;
END;

PROCEDURE ExitPGM;
BEGIN
  Dispose(GamesList, Done);
  Dispose(Database, Done);
  ClrScr(7);
  SetPal(OrgPAL);
  ShowPGMLogo;
  WriteBetween(1,80,3,$0B,'Thank you for using');
  PosCursor(1,23);
  Cursor(On);
  SetBlink(True);
  Halt(0);
END;

BEGIN
  Initialize;
  ExitPGM;
END.